'QWinman - Window manager example programmed by Julien Moog - julien.moog@laposte.net
'This example shows with only a few lines of code, a simple way to use multiple windows
'in the same program without the use of the complicate mdi apis
'it uses array of qforms and the setparent api function
'- qrichedit component must be disabled with enable=0, before a window is moved
'i took some portions of code from Jernej Simoncic with his CloseQ custom form with flat close button, thanks to him
'works successfully from Windows 95 to Windows 7
'2014-07-17: modifications made the way it can also work under Ubuntu with Wine (it was laborious!)

'Application settings
$APPTYPE gui
$TYPECHECK on

'Inclusions
$include "rapidq2.inc"
$include "qtabcontrolex.inc"
$include "qgetosversion.inc"
Get_Version

if platform="Wine" then 
CONST ES_NUMBER=&H2000
end if

'Ressources
$RESOURCE CloseUp AS "CLOSE_UP.BMP"
$RESOURCE CloseDn AS "CLOSE_DN.BMP"
$RESOURCE CloseFl AS "CLOSE_FLAT.BMP"

'Public declarations
DECLARE SUB newchild
DECLARE SUB tabchange
DECLARE SUB checkfrmfocusontimer
DECLARE SUB closechildform
DECLARE SUB StartMoveForm(BTN AS INTEGER , X AS INTEGER , Y AS INTEGER)
DECLARE SUB MoveForm(X AS INTEGER , Y AS INTEGER)
DECLARE SUB EndMoveForm(BTN AS INTEGER , X AS INTEGER , Y AS INTEGER)
DECLARE SUB CloseClick
DECLARE SUB CloseDown(BTN AS INTEGER , X AS INTEGER , Y AS INTEGER)
DECLARE SUB CloseMove(x% , y%)
DECLARE SUB CloseLift
DECLARE SUB CloseDraw
DECLARE SUB closetab
DECLARE FUNCTION DestroyWindow LIB "user32" ALIAS "DestroyWindow"(ByVal hwnd AS LONG) AS LONG
if platform="Wine" then
declare sub init
declare sub getmousepos
declare function windowfrompoint lib "user32" alias "WindowFromPoint" (byval xpoint as long,byval ypoint as long) as long
end if

'Variables declaration
DIM x1% AS INTEGER , x2% AS INTEGER , y1% AS INTEGER , y2% AS INTEGER , Moving AS INTEGER , Clse AS INTEGER , Min AS INTEGER
DIM CDown(1) AS INTEGER , MDown(1) AS INTEGER , UpOrDown AS INTEGER , i% AS INTEGER
DEFINT j = 0
DIM childnbhandle(0 TO 99) AS long
DIM frmfocustimer AS QTIMER
frmfocustimer.Interval = 100
frmfocustimer.OnTimer = checkfrmfocusontimer
DIM previoushandlefocus AS INTEGER
DIM publicchildfocusnb AS INTEGER
DIM tabchild(0 TO 99) AS INTEGER
DIM mousexdiff AS INTEGER
DIM mouseydiff AS INTEGER
if platform="Wine" then
dim curstyle as long
dim initialhandlefocus as long
dim mousetimer as qtimer
mousetimer.interval=300
mousetimer.ontimer=getmousepos
dim mouseposx as long
dim mouseposy as long
dim mousehandleclick as long
dim firsttimemovechildform(0 TO 99) as integer
end if

'GUI objects creation
DIM form AS qformex
form.Width = SCREEN.Width * 0.8
form.Height = SCREEN.Height * 0.8
form.Caption = "QWinman"
if platform="Wine" then
form.onshow=init
end if

DIM Tab AS QTabControlex
WITH Tab
    .Parent = form
    .Width = form.ClientWidth
    .Height = form.ClientHeight
    .Top = 30
    .OnChange = tabchange
    .HotTrack = TRUE
    .Visible = 0
END WITH

DIM Tabshow AS QTabControlex
WITH Tabshow
    .Parent = form
    .Width = form.ClientWidth
    .Height = form.ClientHeight
    .OnChange = tabchange
    .HotTrack = TRUE
    .Align = 0
END WITH

DIM scrollbox AS QSCROLLBOX
WITH scrollbox
    .Parent = Tabshow
    .Height = Tabshow.ClientHeight - 30
    .Top = Tabshow.Top
    .Width = Tabshow.ClientWidth
    .Align = 2
END WITH



DIM windbut AS QBUTTON
windbut.Parent = scrollbox
windbut.Top = 10
windbut.Left = 10
windbut.Caption = "New window"
windbut.OnClick = newchild

DIM closetabbut AS QBUTTON
closetabbut.Parent = scrollbox
closetabbut.Top = 10
closetabbut.Left = 100
closetabbut.Caption = "Close tab"
closetabbut.OnClick = closetab

DIM childform(0 TO 99) AS QFORM
DIM btnExit(0 TO 99) AS QCOOLBTN
DIM DragImg(0 TO 99) AS QSCROLLBOX
DIM childbox(0 TO 99) AS QSCROLLBOX
DIM childcaption(0 TO 99) AS QLABEL
DIM childcaptionfont(0 TO 99) AS QFONT
DIM childrichedit(0 TO 99) AS QRICHEDIT

'Subroutines and functions
SUB newchild

    Tab.AddTabs STR$(j)
    Tabshow.AddTabs STR$(j)

    childform(j).BorderStyle = 0
    Setparent(childform(j).Handle , scrollbox.Handle)

    childform(j).Top = 10
    childform(j).Left = 10
    childform(j).Caption = "Window " + STR$(j)
    childform(j).OnClose = closechildform

if platform="Wine" then
curstyle=getwindowlong(scrollbox.handle,GWL_STYLE)
setwindowlong(childform(j).Handle,GWL_STYLE,curstyle)
end if

    childnbhandle(j) = childform(j).Handle

    DragImg(j).Parent = childform(j)
    DragImg(j).Left = 0
    DragImg(j).Top = 0
    DragImg(j).Width = childform(j).ClientWidth + 20
    DragImg(j).Height = childform(j).ClientHeight
    DragImg(j).Color = RGB(0 , 0 , 144)
    DragImg(j).OnMouseDown = StartMoveForm
    DragImg(j).OnMouseMove = MoveForm
    DragImg(j).OnMouseUp = EndMoveForm

    childbox(j).Parent = DragImg(j)
    childbox(j).Width = DragImg(j).Width - 22
    childbox(j).Height = DragImg(j).Height - 24
    childbox(j).Top = DragImg(j).Top + 20
    childbox(j).Left = DragImg(j).Left
    childbox(j).Color = RGB(222 , 222 , 222)

    btnExit(j).Parent = DragImg(j)
    btnExit(j).Top = 3
    btnExit(j).Left = childform(j).ClientWidth - 18
    btnExit(j).Height = 14
    btnExit(j).Width = 15
    btnExit(j).BMPHandle = CloseFl
    btnExit(j).OnMouseDown = CloseDown
    btnExit(j).OnMouseMove = CloseMove
    btnExit(j).OnMouseUp = CloseLift
    btnExit(j).OnClick = CloseClick

    childcaptionfont(j).Name = "Arial"
    childcaptionfont(j).Color = RGB(222 , 222 , 222)

    childcaption(j).Parent = DragImg(j)
    childcaption(j).Enabled = 0
    childcaption(j).Top = 3
    childcaption(j).Left = 3
    childcaption(j).Height = 20
    childcaption(j).Width = 100
    childcaption(j).Font = childcaptionfont(j)
    childcaption(j).Caption = "Window " + STR$(j)

    childrichedit(j).Parent = childbox(j)
    childrichedit(j).Enabled = 1
    childrichedit(j).ScrollBars = ssBoth
    childrichedit(j).Left = 0
    childrichedit(j).Top = 0
    childrichedit(j).Height = childbox(j).Height - 4
    childrichedit(j).Width = childbox(j).Width - 4
    childrichedit(j).Text = "Welcome to QWinman, a cool window manager programmed by Julien Moog - julien.moog@laposte.net " + CHR$(10) + CHR$(10)
    childrichedit(j).Text = childrichedit(j).Text + "This example shows with only a few lines of code, a simple way to use multiple windows "
    childrichedit(j).Text = childrichedit(j).Text + "in the same program without the use of the complicate mdi apis. " + CHR$(10) + CHR$(10)
    childrichedit(j).Text = childrichedit(j).Text + "It uses array of qforms and the setparent api function. " + CHR$(10) + CHR$(10)

    childform(j).Show

    j ++

END SUB

SUB tabchange

    Tab.TabIndex = VAL(Tabshow.Tab(Tabshow.TabIndex))
    setfocus childform(Tab.TabIndex).Handle
    if platform="Wine" then
setwindowpos childform(Tab.TabIndex).Handle,HWND_TOPMOST,0,0,0,0,SWP_NOACTIVATE or SWP_SHOWWINDOW or SWP_NOMOVE or SWP_NOSIZE
end if

END SUB

SUB checkfrmfocusontimer

    DEFINT hwnd = getfocus()
    IF hwnd <> previoushandlefocus THEN
        previoushandlefocus = hwnd
        DEFINT i
        DEFINT j
        FOR i = 0 TO 99
            DragImg(i).Color = RGB(0 , 0 , 144)
            IF childrichedit(publicchildfocusnb).Enabled = 0 THEN childrichedit(i).Enabled = 0
        NEXT i
        FOR i = 0 TO 99
            IF childnbhandle(i) = hwnd THEN
                publicchildfocusnb = i
                IF childrichedit(publicchildfocusnb).Enabled = 0 THEN childrichedit(publicchildfocusnb).Enabled = 1
                DragImg(i).Color = RGB(0 , 0 , 200)
                Tab.TabIndex = i
                FOR j = 0 TO 99
                    IF Tabshow.Tab(j) = STR$(i) THEN
                        Tabshow.TabIndex = j
                        EXIT FOR
                    END IF
                NEXT j
                EXIT FOR
            END IF
        NEXT i
    END IF

END SUB

SUB closechildform

    DEFINT i
    FOR i = 0 TO 99
        IF Tabshow.Tab(i) = STR$(publicchildfocusnb) THEN
            Tabshow.deletetabs i
            EXIT FOR
        END IF
    NEXT i

END SUB

SUB StartMoveForm(BTN AS INTEGER , X AS INTEGER , Y AS INTEGER)

if platform="Wine" then
mousehandleclick=windowfrompoint(mouseposx,mouseposy)-2
end if

    IF Btn = 0 THEN
        if platform<>"Wine" then DEFINT hwnd = getfocus()
        DEFINT i
        FOR i = 0 TO 99
            childrichedit(i).Enabled = 0
            if platform="Wine" then
            IF childnbhandle(i) = mousehandleclick THEN
                publicchildfocusnb = i
                setfocus childform(publicchildfocusnb).Handle
            END IF
            end if
            if platform<>"Wine" then
            IF childnbhandle(i) = hwnd THEN
                publicchildfocusnb = i
                setfocus childform(publicchildfocusnb).Handle
            END IF
            end if
        NEXT i
        x2% = childform(publicchildfocusnb).Left
        y2% = childform(publicchildfocusnb).Top
        if platform="Wine" then	
	mousexdiff = SCREEN.MouseX - x2% + scrollbox.Left' + form.Left
        mouseydiff = SCREEN.MouseY - y2% '+ form.Top + Tab.Top + scrollbox.Top
	if firsttimemovechildform(publicchildfocusnb)=0 then
	mousexdiff = SCREEN.MouseX - x2% + scrollbox.Left + form.Left
        mouseydiff = SCREEN.MouseY - y2% + form.Top + Tab.Top + scrollbox.Top
	firsttimemovechildform(publicchildfocusnb)=1       
	end if
	setwindowpos mousehandleclick,HWND_TOPMOST,0,0,0,0,SWP_NOACTIVATE or SWP_SHOWWINDOW or SWP_NOMOVE or SWP_NOSIZE
        end if
        if platform<>"Wine" then
        mousexdiff = SCREEN.MouseX - x2% + scrollbox.Left + form.Left
        mouseydiff = SCREEN.MouseY - y2% + Tab.Top + scrollbox.Top + form.Top
        end if
        Moving = TRUE
    END IF

END SUB

SUB MoveForm(X AS INTEGER , Y AS INTEGER)

    IF Moving = TRUE THEN
    if platform<>"Wine" then
        MoveWindow childform(publicchildfocusnb).Handle , SCREEN.MouseX - mousexdiff , SCREEN.MouseY - mouseydiff , childform(publicchildfocusnb).Width , childform(publicchildfocusnb).Height , 1
    end if
    if platform="Wine" then
childform(publicchildfocusnb).top=SCREEN.MouseY - mouseydiff
childform(publicchildfocusnb).left=SCREEN.MouseX - mousexdiff
end if
    ELSE
        CDown(0) = 0
        CloseDraw
    END IF
END SUB

SUB EndMoveForm(BTN AS INTEGER , X AS INTEGER , Y AS INTEGER)

    Moving = FALSE
    childrichedit(publicchildfocusnb).Enabled = 1
if platform="Wine" then    
setfocus (initialhandlefocus)
end if

END SUB

SUB CloseDown(BTN AS INTEGER , X AS INTEGER , Y AS INTEGER)

    IF BTN = 0 THEN
        btnExit(publicchildfocusnb).BMPHandle = CloseDn
        Clse = TRUE
        CDown(0) = - 1
    END IF

END SUB

SUB CloseMove(x% , y%)

    IF Clse = TRUE THEN
        IF x% > 0 AND x% < 15 THEN
            IF y% > 0 AND y% < 14 THEN
                CDown(0) = - 1
            ELSE
                CDown(0) = 0
            END IF
        ELSE
            CDown(0) = 0
        END IF
    ELSE
        CDown(0) = 1
    END IF
    CloseDraw

END SUB

SUB CloseLift

    btnExit(publicchildfocusnb).BMPHandle = CloseFl
    Clse = 0
    CDown(0) = FALSE

END SUB

SUB CloseDraw

    IF CDown(0) <> CDown(1) THEN
        IF CDown(0) = - 1 THEN
            btnExit(publicchildfocusnb).BMPHandle = CloseDn
        ELSEIF CDown(0) = 1 THEN
            btnExit(publicchildfocusnb).BMPHandle = CloseUp
        ELSE
            btnExit(publicchildfocusnb).BMPHandle = CloseFl
        END IF
        CDown(1) = CDown(0)
    END IF

END SUB

SUB CloseClick

    childform(publicchildfocusnb).Close

END SUB

SUB closetab

    DEFINT tabshowtabindex = VAL(Tabshow.Tab(Tabshow.TabIndex))

    DEFINT i
    FOR i = 0 TO 99
        IF Tabshow.Tab(i) = STR$(tabshowtabindex) THEN
            Tabshow.deletetabs i
            EXIT FOR
        END IF
    NEXT i

    CALL DestroyWindow(childform(tabshowtabindex).Handle) 'Avoid calling the closechildform sub from the onclose event, else it bugs

END SUB

if platform="Wine" then
sub init

initialhandlefocus=getfocus()

end sub

sub getmousepos
mouseposx=screen.mousex
mouseposy=screen.mousey
end sub
end if

'Display form and wait for result
form.ShowModal
